## arpon 1.90

=== Makefile ===
SOURCE = arpon.c
EXEC = arpon
MAN = man8/arpon.8

CFLAGS += -g -Wall -Werror
LDFLAGS +=

LIBS_OSX = -lpthread -lpcap -ldnet -lnet -L/opt/local/lib/ -I/opt/local/include/
LIBS_FREEBSD = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include -L/usr/local/lib/libnet11 -I/usr/local/include/libnet11 
LIBS_NETBSD = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include -L/usr/lib/libnet11 -I/usr/include/libnet11
LIBS_OPENBSD = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include
LIBS_LINUX = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include
LIBS_DEBIAN = -lpthread -lpcap -ldumbnet -lnet -L/usr/lib -I/usr/include
LIBS_GENTOO = -lpthread -lpcap -ldnet -lnet -L/usr/lib -I/usr/include

arpon:
	@echo ""
	@echo "  Portings avaible:" 
	@echo "  ================="
	@echo "  - MAC OS X       run:  make osx"
	@echo "  - FreeBSD        run:  make freebsd"
	@echo "  - NetBSD         run:  make netbsd"
	@echo "  - OpenBSD        run:  make openbsd" 
	@echo "  - Linux          run:  make linux"
	@echo "  - Linux Debian   run:  make debian"	
	@echo "  - Linux Gentoo   run:  make gentoo"
	@echo ""
	@echo "If you have problems, read INSTALL file."	
	@echo ""

osx: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_OSX) -o $(EXEC) $(SOURCE)

freebsd: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_FREEBSD) -o $(EXEC) $(SOURCE)

netbsd: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_NETBSD) -DNETBSD -o $(EXEC) $(SOURCE)

openbsd: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_OPENBSD) -DOPENBSD -o $(EXEC) $(SOURCE)

linux: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_LINUX) -DLINUX -o $(EXEC) $(SOURCE)

debian: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_DEBIAN) -DLINUX -DDEBIAN -o $(EXEC) $(SOURCE)

gentoo: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_GENTOO) -DLINUX -o $(EXEC) $(SOURCE)

clean:
	rm -f $(EXEC)

install:
	install $(EXEC) $(DESTDIR)/sbin
	install $(MAN) $(DESTDIR)/usr/share/man/man8/

uninstall:
	rm -f $(DESTDIR)/sbin/$(EXEC)
	rm -f $(DESTDIR)/usr/share/man/$(MAN)

.PHONY: arpon osx freebsd netbsd openbsd linux debian gentoo clean install uninstall

## arpon 2.0

=== CMakeLists.txt ===
# CMakeLists.txt build arpon.c with cmake
#
# The following variables are set:
# CMAKE_C_FLAGS - flags to add to the C compiler for build arpon
# CMAKE_LIBS - set the library flags to add to the C compiler for build arpon
# CMAKE_INCLUDE - set the include flags  to add to the C compiler for build arpon
# CMAKE_INSTALL_PREFIX - set the install prefix for arpon. By default
#		arpon will be installed to /usr/loca/ path.
#
#
# Copyright 2010 <Giuseppe Marco Randazzo> zeld@freaknet.org
#
# Redistribution AND use is allowed according to the terms of the New
# BSD license.

cmake_minimum_required(VERSION 2.6)
project(ArpON)
set(AUTHOR "Andrea Di Pasquale" INTERNAL "Author")
set(VERSION "2.0")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror -ggdb")

set(CMAKE_LIBRARY_PATH /usr/lib/;/usr/local/lib/;
  /opt/local/lib/;/usr/local/lib/libnet11/;
  /usr/lib/libnet11/;/usr/lib/libnet113/;
  /usr/local/lib/libnet113/;/usr/lib/libnet-1.1/;
  /usr/local/lib/libnet-1.1/;/usr/pkg/lib/;
  /usr/pkg/lib/libnet11;${CMAKE_LIBRARY_PATH})

set(CMAKE_INCLUDE_PATH /usr/include/;/usr/local/include/;
  /opt/local/include/;/usr/local/include/libnet11/;
  /usr/include/libnet11/;/usr/include/libnet113/;
  /usr/local/include/libnet113/;/usr/include/libnet-1.1/;
  /usr/local/include/libnet-1.1/;/usr/pkg/include;
  /usr/pkg/include/libnet11;${CMAKE_INCLUDE_PATH})

set(CMAKE_INSTALL_PREFIX "/")

include_directories("/usr/include")
link_directories("/usr/lib")

set(INCLUDE_DIR "/usr/include")
set(LIB_DIR "/usr/lib")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules/")
find_package(System)
find_package(Pthread)
find_package(DNET)
find_package(NET)
find_package(PCAP)

add_subdirectory(src)
add_subdirectory(man8)
add_subdirectory(etc)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in" 
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P 
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")



set(MAJOR_VERSION 2)
set(MINOR_VERSION 0)
#set(PATCH_VERSION 0)
set(ARPON_NAME "arpon")

if(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake")
  include(InstallRequiredSystemLibraries)

  set(CPACK_GENERATOR "DEB;RPM;TBZ2;TGZ;STGZ")

  set(CPACK_PACKAGE_DESCRIPTION "ArpON  (Arp  handler inspectiON) is a portable handler daemon that make Arp secure in order to avoid Arp Spoofing/Poisoning & co. This is possible using two kinds of anti Arp Poisoning  tecniques,  the first is based on SARPI or 'Static Arp Inspection', the second on DARPI or 'Dynamic Arp Inspection' approach. Keep in mind other common tools fighting ARP  poisoning  usually  limit their  activity  only  to point out the problem instead of blocking it, ArpON does it using SARPI and DARPI  policies.   Finally  you  can  use ArpON  to  pentest some switched/hubbed LAN with/without DHCP protocol, in fact you can disable the daemon in order to use the tools to  poison the ARP Cache. Remember it doesn't affect the communication efficiency of the ARP pro‐tocol!")

  set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ArpON is a portable handler daemon that make Arp secure in order to avoid Arp Spoofing/Poisoning & co.")
  set(CPACK_PACKAGE_VENDOR  "zeld")
  set(CPACK_PACKAGE_CONTACT  "zeld <zeld@freaknet.org>")
  set(CPACK_PACKAGING_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
  set(CPACK_PACKAGE_VERSION_MAJOR     "${MAJOR_VERSION}")
  set(CPACK_PACKAGE_VERSION_MINOR     "${MINOR_VERSION}")
  set(CPACK_PACKAGE_VERSION_PATCH "${PATCH_VERSION}")
  #set(CPACK_PACKAGE_FILE_NAME     "${CMAKE_PROJECT_NAME}-${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}")
  #set(CPACK_SOURCE_PACKAGE_FILE_NAME  "${CMAKE_PROJECT_NAME}-${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}")
  set(CPACK_PACKAGE_FILE_NAME     "${CMAKE_PROJECT_NAME}-${MAJOR_VERSION}.${MINOR_VERSION}")
  set(CPACK_SOURCE_PACKAGE_FILE_NAME  "${CMAKE_PROJECT_NAME}-${MAJOR_VERSION}.${MINOR_VERSION}")


  set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.4), libdumbnet1, libnet1 (>= 1.1.2.1), libpcap0.8 (>= 0.9.3-1), lsb-base")
  set(CPACK_DEBIAN_PACKAGE_SECTION "universe/net")

  #set(CPACK_RPM_PACKAGE_LICENSE "BSD")
  #set(CPACK_RPM_PACKAGE_GROUP "Administration Tools")
  #set(CPACK_RPM_PACKAGE_REQUIRES "")

  set(CPACK_STRIP_FILES TRUE)
  set(CPACK_COMPONENTS_ALL Etcfile Man Application)

  include(CPack)
else(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake")
  message(FATAL_ERROR "${CMAKE_ROOT}/Modules/CPack.cmake not found! Unable to make package.")
endif(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake")

=== Makefile ===
SOURCE = src/arpon.c
EXEC = src/arpon
EXEC_FILE = arpon
MAN = man8/arpon.8
FILE = etc/arpon.sarpi

CFLAGS += -g -Wall -Werror
LDFLAGS +=

LIBS_LINUX = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include
LIBS_DEBIAN = -lpthread -lpcap -ldumbnet -lnet -L/usr/lib -I/usr/include
LIBS_GENTOO = -lpthread -lpcap -ldnet -lnet -L/usr/lib -I/usr/include
LIBS_OSX = -lpthread -lpcap -ldnet -lnet -L/opt/local/lib/ -I/opt/local/include/
LIBS_FREEBSD = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include -L/usr/local/lib/libnet11 -I/usr/local/include/libnet11
LIBS_FREEBSD_NEW = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include -L/usr/local/lib/libnet113 -I/usr/local/include/libnet113 
LIBS_NETBSD = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include -L/usr/lib/libnet11 -I/usr/include/libnet11
LIBS_NETBSD_NEW = -lpthread -lpcap -ldnet -lnet -L/usr/pkg/lib -I/usr/pkg/include -L/usr/pkg/lib/libnet11 -I/usr/pkg/include/libnet11
LIBS_OPENBSD = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include -L/usr/lib/libnet11 -I/usr/include/libnet11
LIBS_OPENBSD_NEW = -lpthread -lpcap -ldnet -lnet -L/usr/local/lib -I/usr/local/include -L/usr/local/lib/libnet-1.1 -I/usr/local/include/libnet-1.1

arpon:
	@echo ""
	@echo "  Portings avaible:" 
	@echo ""
	@echo "  - Linux          run:  make linux"
	@echo "  - Linux Debian   run:  make debian"	
	@echo "  - Linux Gentoo   run:  make gentoo"
	@echo "  - Mac OS X       run:  make osx"
	@echo "  - FreeBSD        run:  make freebsd"
	@echo "  - FreeBSD new    run:  make freebsd_new"
	@echo "  - NetBSD         run:  make netbsd"
	@echo "  - NetBSD new     run:  make netbsd_new"
	@echo "  - OpenBSD        run:  make openbsd"
	@echo "  - OpenBSD new    run:  make openbsd_new"
	@echo ""
	@echo "  Have got problems? Read INSTALL file."	
	@echo ""

linux: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_LINUX) -DLINUX -o $(EXEC) $(SOURCE)

debian: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_DEBIAN) -DLINUX -DDEBIAN -o $(EXEC) $(SOURCE)

gentoo: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_GENTOO) -DLINUX -o $(EXEC) $(SOURCE)

osx: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_OSX) -o $(EXEC) $(SOURCE)

freebsd: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_FREEBSD) -o $(EXEC) $(SOURCE)

freebsd_new: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_FREEBSD_NEW) -o $(EXEC) $(SOURCE)

netbsd: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_NETBSD) -DNETBSD -o $(EXEC) $(SOURCE)

netbsd_new: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_NETBSD_NEW) -DNETBSD -o $(EXEC) $(SOURCE) /usr/pkg/lib/libnet11/libnet.a

openbsd: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_OPENBSD) -DOPENBSD -o $(EXEC) $(SOURCE)

openbsd_new: $(SOURCE)
	gcc $(CFLAGS) $(LDFLAGS) $(LIBS_OPENBSD_NEW) -DOPENBSD -o $(EXEC) $(SOURCE)

clean:
	rm -f $(EXEC)

install:
	cp $(EXEC) $(DESTDIR)/sbin
	cp $(FILE) $(DESTDIR)/etc
	cp $(MAN) $(DESTDIR)/usr/share/man/man8/

uninstall:
	rm -f $(DESTDIR)/sbin/$(EXEC_FILE)
	rm -f $(DESTDIR)/$(FILE)
	rm -f $(DESTDIR)/usr/share/man/$(MAN)

.PHONY: arpon osx freebsd netbsd openbsd linux debian gentoo clean install uninstall

=== etc/CMakeLists.txt ===
# Install arpon.sarpi
#
# Copyright 2010 <Giuseppe Marco Randazzo> zeld@freaknet.org
#
# Redistribution AND use is allowed according to the terms of the New
# BSD license.

set(arpon_etc_src "${CMAKE_SOURCE_DIR}/etc/arpon.sarpi")

install(FILES ${arpon_etc_src}
  DESTINATION "/etc/"
  PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
  COMPONENT Etcfile)

=== man8/CMakeLists.txt ===
# Compress man pages
#
# Copyright 2010 <Giuseppe Marco Randazzo> zeld@freaknet.org
#
# Redistribution AND use is allowed according to the terms of the New
# BSD license.

set(arpon_man_src "${CMAKE_SOURCE_DIR}/man8/arpon.8")

find_program(BZIP_TOOL NAMES bzip2 PATHS /bin
  /sbin
  /usr/bin
  /usr/sbin
  /usr/local/bin
  /usr/local/sbin)

add_custom_command(OUTPUT ${arpon_man_src}.bz2 
  COMMAND ${BZIP_TOOL} -c ${arpon_man_src} > ${arpon_man_src}.bz2
  DEPENDS ${arpon_man_src}
  COMMENT "Building arpon man pages.")

add_custom_target(arpon_man_src ALL DEPENDS ${arpon_man_src}.bz2)

install(FILES ${arpon_man_src}.bz2
  DESTINATION "/usr/share/man/man8/"
  PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
  COMPONENT Man)

=== src/CMakeLists.txt ===
# Compile the arpon.c source code
#
# Copyright 2010 <Giuseppe Marco Randazzo> zeld@freaknet.org
#
# Redistribution AND use is allowed according to the terms of the New
# BSD license.


add_executable(arpon arpon.c include/queue.h)

if(UBUNTU OR DEBIAN)
  target_link_libraries(arpon net dumbnet pcap pthread)
else()
  target_link_libraries(arpon net dnet pcap pthread)
endif( UBUNTU OR DEBIAN )

install(TARGETS arpon RUNTIME DESTINATION sbin COMPONENT Application)

=== debian/changelog ===
arpon (2.0-2.1ubuntu1) trusty; urgency=low

  * Handle multiarch libnet1-dev, too, resolving FTBFS.
    (Closes: #718148) (LP: #1229530)

 -- Daniel T Chen <crimsun@ubuntu.com>  Tue, 14 Jan 2014 14:43:14 -0500

arpon (2.0-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS: Libpthread not found!": add patch from Ubuntu / Steve
    Langasek, Andreas Moog, Daniel T Chen:
    - debian/patches/fix_multiarch.patch: multiarch libpcap
      (LP: #747889, #831092)
    (Closes: #634578, #620459)

 -- gregor herrmann <gregoa@debian.org>  Fri, 04 Nov 2011 00:25:54 +0100

arpon (2.0-2) unstable; urgency=low

  * [9ce1735] Fix the default configuration /etc/default/arpon
    (Closes: #592310) - thanks to Luca Bruno
  * [96a4ebf] Uncomment examples in /etc/arpon.sarpi

 -- Giuseppe Iuculano <iuculano@debian.org>  Thu, 19 Aug 2010 19:18:09 +0200

arpon (2.0-1) unstable; urgency=low

  * [26180e8] Switch to quilt
  * [3d1be31] Imported Upstream version 2.0
  * [49351eb] Switch to dpkg-source 3.0 (quilt) format
  * [aeb7386] Bump to debhelper 7 compatibility
  * [e3882e9] added cmake, lsb-release in Build-Depends
  * [b598014] Use new cmake build system
  * [6a7cc92] Use dh_prep
  * [670ccab] updated copyright file
  * [fba9537] Install binary in usr/sbin
  * [f197a87] debian/init.d: Added $remote_fs in Required-Start and
    Required-Stop
  * [bcd8d8c] updated copyright file
  * [6bc5b28] Bump to standard-version 3.9.1, no changes needed
  * [e14a181] Updated my email address

 -- Giuseppe Iuculano <iuculano@debian.org>  Wed, 04 Aug 2010 13:29:45 +0200

arpon (1.90-1) unstable; urgency=low

  * New upstream release
  * debian/rules: use new make debian target
  * debian/docs: Added AUTHORS
  * Added debian/patches/02_fix_hypen.dpatch to fix hyphen-used-as-minus-sign

 -- Giuseppe Iuculano <giuseppe@iuculano.it>  Fri, 17 Oct 2008 20:01:06 +0200

arpon (1.50-1) unstable; urgency=low

  * Initial release (Closes: #492922)

 -- Giuseppe Iuculano <giuseppe@iuculano.it>  Tue, 19 Aug 2008 14:11:26 +0200

=== debian/control ===
Source: arpon
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Giuseppe Iuculano <iuculano@debian.org>
Build-Depends: debhelper (>= 7), libnet1-dev, libpcap-dev, libdumbnet-dev, cmake, lsb-release
Standards-Version: 3.9.1
Homepage: http://arpon.sourceforge.net

Package: arpon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
Description: versatile anti ARP poisoning daemon
 ArpON (Arp handler inspectiON) is a portable handler daemon with some nice
 tools to handle all ARP aspects.
 It makes Arp a bit safer. This is possible using two kinds of anti Arp
 Poisoning techniques, the first is based on SARPI or "Static Arp Inspection",
 the second on DARPI or "Dynamic Arp Inspection" approach.
 .
 Features of ArpON include:
   * Detects and blocks ARP Poisoning/Spoofing attacks in statically
     configured networks (SARPI)
   * Detects and blocks ARP Poisoning/Spoofing attacks in dynamically
     configured (DHCP) networks (DARPI)
   * Detects and blocks unidirectional and bidirectional ARP attacks
   * Easily configurable via command line switches
   * Works in userspace
   * Can be a passive sniffer and capture all inbound/outbound ARP packets

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
	CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS_RELEASE = -O0 -g -DNDEBUG $(CFLAGS)
	CFLAGS_DEBUG   = -O0 -g $(CFLAGS)
else
	CFLAGS_RELEASE = -O2 -g -DNDEBUG $(CFLAGS)
	CFLAGS_DEBUG   = -O2 -g $(CFLAGS)
endif

BUILD_TYPE = Release
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	BUILD_TYPE = Debug
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

BUILD_FLAGS = -DCMAKE_INSTALL_PREFIX=/usr -DRESOURCEDIR=/usr/share/arpon -DCMAKE_BUILD_TYPE=$(BUILD_TYPE) \
	      -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS_RELEASE)" -DCMAKE_C_FLAGS_DEBUG="$(CFLAGS_DEBUG)" 

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	BUILD_FLAGS += -DCMAKE_SYSTEM_NAME=$(shell dpkg-architecture -qDEB_BUILD_ARCH_OS) \
		       -DCMAKE_SYSTEM_PROCESSOR=$(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU) \
		       -DCMAKE_C_COMPILER=$(DEB_BUILD_GNU_TYPE)-gcc
endif

CFLAGS += -Wall -Werror

debian/build/CMakeCache.txt:
	mkdir -p debian/build
	cd $(CURDIR)/debian/build && \
		cmake $(BUILD_FLAGS) ../..

debian/build: debian/build/CMakeCache.txt

build: build-stamp

build-stamp: debian/build
	dh_testdir
	$(MAKE) -C debian/build CFLAGS="$(CFLAGS)" $(MAKEFLAGS)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	[ ! -f Makefile ] || $(MAKE) clean
	rm -rf debian/build/
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep 
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/arpon install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGELOG
	dh_installdocs
	dh_installexamples
	dh_install
	dh_installlogrotate
	dh_installinit
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## arpon 2.7.2

=== CMakeLists.txt ===
# - Build arpon
#
# The following variables can be modified:
#
# CMAKE_C_FLAGS        - Set flags for the C compiler
# CMAKE_BUILD_TYPE     - Set build type: release or debug
# CMAKE_LIBRARY_PATH   - Set the library path
# CMAKE_INCLUDE_PATH   - Set the include path
# CMAKE_INSTALL_PREFIX - Set the install prefix for arpon.
#                        By default arpon will be installed to /usr/loca/ path.
#
# Copyright 2014 <Giuseppe Marco Randazzo> gmrandazzo@gmail.com
#
# Redistribution AND use is allowed according to the terms of the BSD 3 clause

cmake_minimum_required(VERSION 2.6)
project(ArpON)
set(AUTHOR "Andrea Di Pasquale" INTERNAL "Author")
set(VERSION "2.7.2")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: Debug Release" FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "ArpON install prefix" FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

set(CMAKE_LIBRARY_PATH /lib;
                       /usr/lib;
                       /usrc/lib64;
                       /usr/local/lib;
                       /usr/local/lib64;
                       /usr/local/lib/libnet11;
                       /usr/local/lib/libnet-1.1;
                       /usr/pkg/lib;
                       /usr/pkg/lib/libnet11;
                       /opt/csw/lib;
                       ${CMAKE_LIBRARY_PATH})

set(CMAKE_INCLUDE_PATH /usr/include/;
                       /usr/local/include/;
                       /usr/local/include/libnet11;
                       /usr/local/include/libnet-1.1;
                       /usr/pkg/include;
                       /usr/pkg/include/libnet11;
                       /opt/csw/include;
                       ${CMAKE_INCLUDE_PATH})

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_tolower)
if(cmake_build_type_tolower STREQUAL "debug")
  message(STATUS "Build Type: Debug")
  set(CMAKE_BUILD_TYPE "Debug")
  set(CMAKE_C_FLAGS "-Wall -Werror -pedantic -O0 -g")
else()
  message(STATUS "Build Type: Release")
  set(CMAKE_BUILD_TYPE "Release")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
endif()

include_directories(
  ${PROJECT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/src
  ${CMAKE_CURRENT_BINARY_DIR} 
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_INCLUDE_PATH}
)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules/")
find_package(System)
find_package(Pthread)
find_package(DNET)
find_package(NET)
find_package(PCAP)

add_subdirectory(src)
add_subdirectory(man8)
add_subdirectory(etc)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in" 
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P 
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== etc/CMakeLists.txt ===
# Install arpon.sarpi
#
# Copyright 2014 <Giuseppe Marco Randazzo> gmrandazzo@gmail.com
#
# Redistribution AND use is allowed according to the terms of the New
# BSD license.

set(arpon_etc_src "${CMAKE_SOURCE_DIR}/etc/arpon.sarpi")

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
  install(FILES ${arpon_etc_src}
    DESTINATION /etc
    PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
    COMPONENT Etcfile)
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
  install(FILES ${arpon_etc_src}
    DESTINATION ${CMAKE_INSTALL_PREFIX}/etc
    PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
    COMPONENT Etcfile)
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

=== man8/CMakeLists.txt ===
  # Compress man pages
#
# Copyright 2014 <Giuseppe Marco Randazzo> gmrandazzo@gmail.com
#
# Redistribution AND use is allowed according to the terms of the New
# BSD license.

set(arpon_man_src "${CMAKE_SOURCE_DIR}/man8/arpon.8")

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
  set(arpon_sarpi_file "/etc/arpon.sarpi")
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
  set(arpon_sarpi_file "${CMAKE_INSTALL_PREFIX}/etc/arpon.sarpi")
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

FILE(READ ${arpon_man_src} FILE_CONTENT)
STRING(REGEX REPLACE "arpon_sarpi" "${arpon_sarpi_file}"  MODIFIED_FILE_CONTENT "${FILE_CONTENT}")
FILE(WRITE ${PROJECT_BINARY_DIR}/man8/arpon.8 "${MODIFIED_FILE_CONTENT}")

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
  INSTALL(FILES ${PROJECT_BINARY_DIR}/man8/arpon.8 DESTINATION /usr/share/man/man8
    PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
    COMPONENT Man)
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
  INSTALL(FILES ${PROJECT_BINARY_DIR}/man8/arpon.8 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man8
    PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
    COMPONENT Man)
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

=== src/CMakeLists.txt ===
# Compile the arpon.c source code
#
# Copyright 2014 <Giuseppe Marco Randazzo> gmrandazzo@gmail.com
#
# Redistribution AND use is allowed according to the terms of the BSD 3 clause

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
  set(arpon_sarpi /etc/arpon.sarpi)
  set(install_prefix /sbin)
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
  set(arpon_sarpi ${CMAKE_INSTALL_PREFIX}/etc/arpon.sarpi)
  set(install_prefix ${CMAKE_INSTALL_PREFIX}/sbin)
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

configure_file (
    "${PROJECT_SOURCE_DIR}/src/config.h.in"
    "${PROJECT_BINARY_DIR}/src/config.h")
include_directories("${PROJECT_BINARY_DIR}/src")

add_executable(arpon arpon.c include/queue.h)
target_link_libraries(arpon ${NET_LIB} ${DNET_LIB} ${PCAP_LIB} ${PTHREAD_LIB})
set_target_properties(arpon PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
install(TARGETS arpon RUNTIME DESTINATION ${install_prefix} COMPONENT Application)

=== debian/changelog ===
arpon (2.7.2-1) unstable; urgency=low

  * [863b18a] Imported Upstream version 2.7.2
  * [8cbe615] Switch to debhelper compat 9
  * [9572355] Switch to Standards-Version 3.9.6, no changes needed
  * [d2a2530] Authors file was renamed to AUTHOR, renamed it in debian/docs
  * [4b478b9] Updated patches and correct /etc/arpon.sarpi install path
  * [f4a52c7] Rewrote debian/rules

 -- Giuseppe Iuculano <iuculano@debian.org>  Sun, 08 Feb 2015 13:21:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: arpon
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Giuseppe Iuculano <iuculano@debian.org>
-Build-Depends: debhelper (>= 7), libnet1-dev, libpcap-dev, libdumbnet-dev, cmake, lsb-release
-Standards-Version: 3.9.1
+Maintainer: Giuseppe Iuculano <iuculano@debian.org>
+Build-Depends: debhelper (>= 9), libnet1-dev, libpcap-dev, libdumbnet-dev, cmake, lsb-release
+Standards-Version: 3.9.6
 Homepage: http://arpon.sourceforge.net
 
 Package: arpon

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@ 

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=3

http://sf.net/arpon/ArpON-(.*)\.tar\.gz

## arpon 3.0

=== CMakeLists.txt ===
#
# Copyright (C) 2008-2016 Andrea Di Pasquale <spikey.it@gmail.com>
# Copyright (C) 2008-2016 Giuseppe Marco Randazzo <gmrandazzo@gmail.com>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR OR HIS RELATIVES BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF MIND, USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# $ArpON: CMakeLists.txt,v 3.0-ng 01/29/2016 02:52:15 spikey Exp $
#

#
# The following variables can be modified:
#
# CMAKE_BUILD_TYPE     - Set build type: release or debug
# CMAKE_INCLUDE_PATH   - Set the include path
# CMAKE_LIBRARY_PATH   - Set the library path
# CMAKE_C_FLAGS        - Set flags for the C compiler
# CMAKE_INSTALL_PREFIX - Set the install prefix for ArpON.
#                        By default ArpON will be installed to / path.
#

cmake_minimum_required(VERSION 2.6)

project(ArpON C)
set(AUTHOR "Andrea Di Pasquale <spikey.it@gmail.com>" INTERNAL "Author")
set(VERSION "3.0-ng")

set(CMAKE_INCLUDE_PATH
    /usr/include;
    /usr/local/include;
    /usr/local/include/libnet11;
    /usr/local/include/libnet-1.1;
    ${CMAKE_INCLUDE_PATH})

set(CMAKE_LIBRARY_PATH
    /lib;
    /usr/lib;
    /usr/lib32;
    /usr/lib64;
    /usr/local/lib;
    /usr/local/lib32;
    /usr/local/lib64;
    /usr/local/lib/libnet11;
    /usr/local/lib/libnet-1.1;
    ${CMAKE_LIBRARY_PATH})

include_directories(
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_INCLUDE_PATH})

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

find_package(System)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release
        CACHE STRING "Choose the type of build, options are: Debug Release"
        FORCE)
endif(NOT CMAKE_BUILD_TYPE)

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_tolower)

if(cmake_build_type_tolower STREQUAL "debug")
    message(STATUS "Build type: Debug")

    set(CMAKE_BUILD_TYPE "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror -Wextra -Wformat=2 -Winit-self -Wreturn-type -Wswitch-default -Wswitch-enum -Wunused-parameter -Wuninitialized -Wstrict-aliasing=3 -Wstrict-overflow=5 -Wdeclaration-after-statement -Wundef -Wpointer-arith -Wunsafe-loop-optimizations -Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wsizeof-pointer-memaccess -Wlogical-op -Waggregate-return -Wstrict-prototypes -Wold-style-declaration -Wmissing-prototypes -Wmissing-declarations -Wredundant-decls -Wnested-externs -Winline -Wlong-long -Wvariadic-macros -Wvarargs -Wvla -Wdisabled-optimization -Woverlength-strings -O0 -g -ggdb")
else(cmake_build_type_tolower STREQUAL "debug")
    message(STATUS "Build type: Release")

    set(CMAKE_BUILD_TYPE "Release")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror -Wextra -O3 -DNDEBUG")
endif(cmake_build_type_tolower STREQUAL "debug")

find_package(Headers)
find_package(Pthreads)
find_package(Librt)
find_package(Libpcap)
find_package(Libnet1)
find_package(Libdnet)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "/" CACHE PATH "ArpON install prefix" FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

if(cmake_build_type_tolower STREQUAL "debug")
    message(STATUS "Include path: ${CMAKE_INCLUDE_PATH}")
    message(STATUS "Library path: ${CMAKE_LIBRARY_PATH}")
    message(STATUS "C compiler flags: ${CMAKE_C_FLAGS}")
    message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
endif(cmake_build_type_tolower STREQUAL "debug")

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(man8)
add_subdirectory(etc)
add_subdirectory(log)
add_subdirectory(run)

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/scripts/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

add_custom_target(clean-all
    COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_SOURCE_DIR}/cmake/scripts/cmake_clean-all.cmake")

#
# EOF
#
# vim:ts=4:expandtab
#

=== etc/CMakeLists.txt ===
#
# Copyright (C) 2008-2016 Andrea Di Pasquale <spikey.it@gmail.com>
# Copyright (C) 2008-2016 Giuseppe Marco Randazzo <gmrandazzo@gmail.com>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR OR HIS RELATIVES BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF MIND, USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# $ArpON: CMakeLists.txt,v 3.0-ng 01/29/2016 02:53:50 spikey Exp $
#

set(arpon_etc_src "${CMAKE_SOURCE_DIR}/etc/arpon.conf")

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    install(FILES ${arpon_etc_src}
        DESTINATION /etc
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
        COMPONENT Etc)
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    install(FILES ${arpon_etc_src}
        DESTINATION ${CMAKE_INSTALL_PREFIX}/etc
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
        COMPONENT Etc)
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

#
# EOF
#
# vim:ts=4:expandtab
#

=== log/CMakeLists.txt ===
#
# Copyright (C) 2008-2016 Andrea Di Pasquale <spikey.it@gmail.com>
# Copyright (C) 2008-2016 Giuseppe Marco Randazzo <gmrandazzo@gmail.com>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR OR HIS RELATIVES BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF MIND, USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# $ArpON: CMakeLists.txt,v 3.0-ng 01/29/2016 02:54:19 spikey Exp $
#

set(arpon_log_src "${CMAKE_SOURCE_DIR}/log/arpon.log")

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    install(FILES ${arpon_log_src}
        DESTINATION /var/log
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ
        COMPONENT Log)
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    install(FILES ${arpon_log_src}
        DESTINATION ${CMAKE_INSTALL_PREFIX}/log
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ
        COMPONENT Log)
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

#
# EOF
#
# vim:ts=4:expandtab
#

=== man8/CMakeLists.txt ===
#
# Copyright (C) 2008-2016 Andrea Di Pasquale <spikey.it@gmail.com>
# Copyright (C) 2008-2016 Giuseppe Marco Randazzo <gmrandazzo@gmail.com>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR OR HIS RELATIVES BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF MIND, USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# $ArpON: CMakeLists.txt,v 3.0-ng 01/29/2016 02:55:15 spikey Exp $
#

set(arpon_man_src "${CMAKE_SOURCE_DIR}/man8/arpon.8")

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    set(ARPON_DOC_FILE
        "/usr/share/doc/arpon/index.html")
    set(ARPON_ETC_FILE
        "/etc/arpon.conf")
    set(ARPON_LOG_FILE
        "/var/log/arpon.log")
    set(ARPON_PID_FILE
        "/var/run/arpon.pid")
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    set(ARPON_DOC_FILE
        "${CMAKE_INSTALL_PREFIX}/share/doc/arpon/index.html")
    set(ARPON_ETC_FILE
        "${CMAKE_INSTALL_PREFIX}/etc/arpon.conf")
    set(ARPON_LOG_FILE
        "${CMAKE_INSTALL_PREFIX}/log/arpon.log")
    set(ARPON_PID_FILE
        "${CMAKE_INSTALL_PREFIX}/run/arpon.pid")
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

file(READ ${arpon_man_src} FILE_CONTENT)
string(REGEX REPLACE "ARPON_DOC" "${ARPON_DOC_FILE}"
    MODIFIED_FILE_CONTENT1 "${FILE_CONTENT}")

string(REGEX REPLACE "ARPON_ETC" "${ARPON_ETC_FILE}"
    MODIFIED_FILE_CONTENT2 "${MODIFIED_FILE_CONTENT1}")

string(REGEX REPLACE "ARPON_LOG" "${ARPON_LOG_FILE}"
    MODIFIED_FILE_CONTENT3 "${MODIFIED_FILE_CONTENT2}")

string(REGEX REPLACE "ARPON_PID" "${ARPON_PID_FILE}"
    MODIFIED_FILE_CONTENT4 "${MODIFIED_FILE_CONTENT3}")
file(WRITE ${PROJECT_BINARY_DIR}/man8/arpon.8 "${MODIFIED_FILE_CONTENT4}")

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    install(FILES
        ${PROJECT_BINARY_DIR}/man8/arpon.8 DESTINATION /usr/share/man/man8
        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        COMPONENT Man)
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    install(FILES
        ${PROJECT_BINARY_DIR}/man8/arpon.8 DESTINATION
        ${CMAKE_INSTALL_PREFIX}/share/man/man8
        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        COMPONENT Man)
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

#
# EOF
#
# vim:ts=4:expandtab
#

=== run/CMakeLists.txt ===
#
# Copyright (C) 2008-2016 Andrea Di Pasquale <spikey.it@gmail.com>
# Copyright (C) 2008-2016 Giuseppe Marco Randazzo <gmrandazzo@gmail.com>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR OR HIS RELATIVES BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF MIND, USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# $ArpON: CMakeLists.txt,v 3.0-ng 01/29/2016 02:55:41 spikey Exp $
#

set(arpon_run_src "${CMAKE_SOURCE_DIR}/run/arpon.pid")

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    install(FILES ${arpon_run_src}
        DESTINATION /var/run
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
        COMPONENT Run)
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    install(FILES ${arpon_run_src}
        DESTINATION ${CMAKE_INSTALL_PREFIX}/run
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
        COMPONENT Run)
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

#
# EOF
#
# vim:ts=4:expandtab
#

=== src/CMakeLists.txt ===
#
# Copyright (C) 2008-2016 Andrea Di Pasquale <spikey.it@gmail.com>
# Copyright (C) 2008-2016 Giuseppe Marco Randazzo <gmrandazzo@gmail.com>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR OR HIS RELATIVES BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF MIND, USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# $ArpON: CMakeLists.txt,v 3.0-ng 01/29/2016 03:07:40 spikey Exp $
#

if(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    set(ARPON_SBIN /sbin/arpon)
    set(ARPON_DOC /usr/share/doc/arpon/index.html)
    set(ARPON_ETC /etc/arpon.conf)
    set(ARPON_LOG /var/log/arpon.log)
    set(ARPON_PID /var/run/arpon.pid)
    set(install_prefix /sbin)
else(${CMAKE_INSTALL_PREFIX} STREQUAL "/")
    set(ARPON_SBIN ${CMAKE_INSTALL_PREFIX}/sbin/arpon)
    set(ARPON_DOC ${CMAKE_INSTALL_PREFIX}/share/doc/arpon/index.html)
    set(ARPON_ETC ${CMAKE_INSTALL_PREFIX}/etc/arpon.conf)
    set(ARPON_LOG ${CMAKE_INSTALL_PREFIX}/log/arpon.log)
    set(ARPON_PID ${CMAKE_INSTALL_PREFIX}/run/arpon.pid)
    set(install_prefix ${CMAKE_INSTALL_PREFIX}/sbin)
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/")

configure_file(
    "${PROJECT_SOURCE_DIR}/src/config.h.in"
    "${PROJECT_BINARY_DIR}/src/config.h")

include_directories("${PROJECT_BINARY_DIR}/src")
add_executable(
    arpon
    arpca.c
    arpca.h
    config.h.in
    darpi.c
    darpica.c
    darpica.h
    darpi.h
    dmn.c
    dmn.h
    env.c
    env.h
    exit.c
    exit.h
    harpi.c
    harpi.h
    intf.c
    intf.h
    ispn.c
    ispn.h
    main.c
    msg.c
    msg.h
    opt.c
    opt.h
    proc.c
    proc.h
    queue.h
    rt.c
    rt.h
    sarpi.c
    sarpica.c
    sarpica.h
    sarpi.h
    sig.c
    sig.h
    std.c
    std.h
    thd.c
    thd.h
    unused.h
    ver.h)

target_link_libraries(arpon
    ${PTHREADS_LIB} ${RT_LIB} ${PCAP_LIB} ${NET_LIB} ${DNET_LIB})

set_target_properties(arpon
    PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)

install(TARGETS arpon
        RUNTIME DESTINATION ${install_prefix}
        COMPONENT Application)

#
# EOF
#
# vim:ts=4:expandtab
#
